import { DataPage } from 'pip-services3-commons-node';
import { FilterParams } from 'pip-services3-commons-node';
import { PagingParams } from 'pip-services3-commons-node';

import { ApplicationV1 } from './ApplicationV1';

export interface IApplicationsClientV1 {
    getApplications(correlationId: string, filter: FilterParams, paging: PagingParams, 
        callback: (err: any, page: DataPage<ApplicationV1>) => void): void;

    getApplicationById(correlationId: string, application_id: string, 
        callback: (err: any, application: ApplicationV1) => void): void;

    createApplication(correlationId: string, application: ApplicationV1, 
        callback: (err: any, application: ApplicationV1) => void): void;

    updateApplication(correlationId: string, application: ApplicationV1, 
        callback: (err: any, application: ApplicationV1) => void): void;

    deleteApplicationById(correlationId: string, application_id: string,
        callback: (err: any, application: ApplicationV1) => void): void;
}
